; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2015																
;																				
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
; INP: temp	(0...127 ASCII, 128...255 inverses ASCII							
;																				
; REGISTER: R0, R1 (werden nicht gesichert)										
;																				
ASCII_TEMP:
	LDS R0,(adr_GRAFIC_FONT) 
	tst R0
	breq ASCII_8x12
	rjmp ASCII_16x24
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_8x12:
	push temp
	push temp1
	push temp2
	push temp6					; invers		
	push temp9					; Schleife		
	push XL						; Bildspeicher	
	push XH
	push ZL						; Tabelle		
	push ZH
;-------------------------------------------------------------------------------
	LDS temp6,(adr_ASCII_INVERS); ASCII invers ?				
	andi temp,0b01111111		; Begrenzung 0...127			
;-------------------------------------------------------------------------------
	ldi ZH, high(FONT_8x12*2)	; FONT-TABELLE Z initialisieren			
	ldi ZL,  low(FONT_8x12*2)
	ldi temp1,24				; mal 2x12	
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
; CURSOR-ZEILE																	
.equ ZEILE_8x12_MAX =18
.equ SPALTE_8x12_MAX=45
	ldi XL,LOW (adr_TV_BILDBEREICH)
	ldi XH,HIGH(adr_TV_BILDBEREICH)
	LDS temp9,(adr_CURSOR_ZEILE)
	cpi temp9,(ZEILE_8x12_MAX)				; ZEILEN-berlauf ?		
	brlo ASCII_8x12_ZEILE_w
	clr temp9	
ASCII_8x12_ZEILE_w:
	tst temp9
	breq ASCII_8x12_SPALTE
	ldi temp1,LOW (45*14)		; Abstand der Zeilen
	ldi temp2,HIGH(45*14)	
ASCII_8x12_s:
	add XL,temp1
	adc XH,temp2
	dec temp9
	brne ASCII_8x12_s
;-------------------------------------------------------------------------------
; CURSOR-SPALTE																	

ASCII_8x12_SPALTE:
	LDS temp,(adr_CURSOR_SPALTE)
	cpi temp,(SPALTE_8x12_MAX)				; SPALTE-berlauf ?		
	brlo ASCII_8x12_SPALTE_w
	clr temp
ASCII_8x12_SPALTE_w:
	add XL,temp
	adc XH,NULL
	inc temp
	cpi temp,(SPALTE_8x12_MAX)				; SPALTEN (ASCII pro ZEILE)
	brlo ASCII_8x12_SPALTE_w2
	LDS temp,(adr_CURSOR_ZEILE)	
	inc temp
	cpi temp,(ZEILE_8x12_MAX)				; ZEILEN					
	brlo ASCII_8x12_SPALTE_w1
	clr temp
ASCII_8x12_SPALTE_w1:
	STS(adr_CURSOR_ZEILE),temp	
	clr temp
ASCII_8x12_SPALTE_w2:
	STS(adr_CURSOR_SPALTE),temp
;-------------------------------------------------------------------------------
	ldi temp9,12					; SCHLEIFE			
ASCII_8x12_s1:
	LPM temp, Z+   					; aus Tabelle laden
	LPM R0,   Z+ 					; DUMMY
	rcall ASCII_BITUMKEHR_TEMP		; BITTAUSCH			
	SBRC temp6,0					; ASCII invers ?				
	com temp						; invertieren					
	ST X+,temp						; in BILDSPEICHER speichern	X+1	
	adiw XL,45-1					; SRAM-ADRESSE auf nchste ZEILE
	dec temp9						; SCHLEIFE			
	brne ASCII_8x12_s1
;-------------------------------------------------------------------------------
	pop ZH
	pop ZL
	pop XH
	pop XL
	pop temp9
	pop temp6
	pop temp2
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_16x24:
	push temp
	push temp1
	push temp2
	push temp6					; invers		
	push temp9					; Schleife		
	push XL						; Bildspeicher	
	push XH
	push ZL						; Tabelle		
	push ZH
;-------------------------------------------------------------------------------
	LDS temp6,(adr_ASCII_INVERS); ASCII invers ?				
	andi temp,0b01111111		; Begrenzung 0...127			
;-------------------------------------------------------------------------------
	ldi ZH, high(FONT_16_24*2)	; FONT-TABELLE Z initialisieren			
	ldi ZL,  low(FONT_16_24*2)
	ldi temp1,48				; mal 2x24=48	
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
; CURSOR-ZEILE																	
	ldi XL,LOW (adr_TV_BILDBEREICH)
	ldi XH,HIGH(adr_TV_BILDBEREICH)
	LDS temp9,(adr_CURSOR_ZEILE)
	cpi temp9,9+1				; berlauf ?		
	brlo ASCII_16x24_ZEILE_w
	clr temp9	
ASCII_16x24_ZEILE_w:
	tst temp9
	breq ASCII_16x24_SPALTE
	ldi temp1,LOW (45*25)		; Abstand der Zeilen
	ldi temp2,HIGH(45*25)	
ASCII_16x24_s:
	add XL,temp1
	adc XH,temp2
	dec temp9
	brne ASCII_16x24_s
;-------------------------------------------------------------------------------
; CURSOR-SPALTE																	
ASCII_16x24_SPALTE:
	LDS temp,(adr_CURSOR_SPALTE)
	cpi temp,(22*2)				; berlauf ?		
	brlo ASCII_16x24_SPALTE_w
	clr temp
ASCII_16x24_SPALTE_w:
	add XL,temp
	adc XH,NULL
	inc temp
	inc temp
	cpi temp,(22*2)				; SPALTEN (ASCII pro ZEILE)
	brlo ASCII_16x24_SPALTE_w2
	LDS temp,(adr_CURSOR_ZEILE)	
	inc temp
	cpi temp,10
	brlo ASCII_16x24_SPALTE_w1
	clr temp
ASCII_16x24_SPALTE_w1:
	STS(adr_CURSOR_ZEILE),temp	
	clr temp
ASCII_16x24_SPALTE_w2:
	STS(adr_CURSOR_SPALTE),temp
;-------------------------------------------------------------------------------
	ldi temp9,24					; SCHLEIFE			
ASCII_16x24_s1:
	LPM temp, Z+   					; aus Tabelle laden	(LOW)
	rcall ASCII_BITUMKEHR_TEMP		; BITTAUSCH			
	mov temp1,temp
	LPM temp, Z+   					; aus Tabelle laden	(HIGH)
	rcall ASCII_BITUMKEHR_TEMP		; BITTAUSCH			
	mov temp2,temp
	SBRC temp6,0					; ASCII invers ?				
	com temp2						; invertieren					
	ST X+,temp2						; in BILDSPEICHER speichern	X+1	
	SBRC temp6,0					; ASCII invers ?				
	com temp1						; invertieren					
	ST X+,temp1						; in BILDSPEICHER speichern	X+1	
	adiw XL,45-2					; SRAM-ADRESSE auf nchste ZEILE
	dec temp9						; SCHLEIFE			
	brne ASCII_16x24_s1
;-------------------------------------------------------------------------------
	pop ZH
	pop ZL
	pop XH
	pop XL
	pop temp9
	pop temp6
	pop temp2
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	STS(adr_ASCII_INVERS),NULL	; !!!
	ret
;-------------------------------------------------------------------------------
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_BITUMKEHR_TEMP:
	MOV R0,temp
	clr temp
	SBRC R0,0
	ori temp,0b10000000
	SBRC R0,1
	ori temp,0b01000000
	SBRC R0,2
	ori temp,0b00100000
	SBRC R0,3
	ori temp,0b00010000
	SBRC R0,4
	ori temp,0b00001000
	SBRC R0,5
	ori temp,0b00000100
	SBRC R0,6
	ori temp,0b00000010
	SBRC R0,7
	ori temp,0b00000001
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEILE_0_CLEAR:
	rcall ZEILE_0
	rcall ZEILE_CLEAR
	rjmp ZEILE_0
ZEILE_1_CLEAR:
	rcall ZEILE_1
	rcall ZEILE_CLEAR
	rjmp ZEILE_1
ZEILE_2_CLEAR:
	rcall ZEILE_2
	rcall ZEILE_CLEAR
	rjmp ZEILE_2
ZEILE_3_CLEAR:
	rcall ZEILE_3
	rcall ZEILE_CLEAR
	rjmp ZEILE_3
ZEILE_4_CLEAR:
	rcall ZEILE_4
	rcall ZEILE_CLEAR
	rjmp ZEILE_4
ZEILE_5_CLEAR:
	rcall ZEILE_5
	rcall ZEILE_CLEAR
	rjmp ZEILE_5
ZEILE_6_CLEAR:
	rcall ZEILE_6
	rcall ZEILE_CLEAR
	rjmp ZEILE_6
ZEILE_7_CLEAR:
	rcall ZEILE_7
	rcall ZEILE_CLEAR
	rjmp ZEILE_7
ZEILE_8_CLEAR:
	rcall ZEILE_8
	rcall ZEILE_CLEAR
	rjmp ZEILE_8
ZEILE_9_CLEAR:
	rcall ZEILE_9
	rcall ZEILE_CLEAR
	rjmp ZEILE_9
ZEILE_10_CLEAR:
	rcall ZEILE_10
	rcall ZEILE_CLEAR
	rjmp ZEILE_10
ZEILE_11_CLEAR:
	rcall ZEILE_11
	rcall ZEILE_CLEAR
	rjmp ZEILE_11
ZEILE_12_CLEAR:
	rcall ZEILE_12
	rcall ZEILE_CLEAR
	rjmp ZEILE_12
ZEILE_13_CLEAR:
	rcall ZEILE_13
	rcall ZEILE_CLEAR
	rjmp ZEILE_13
ZEILE_14_CLEAR:
	rcall ZEILE_14
	rcall ZEILE_CLEAR
	rjmp ZEILE_14
ZEILE_15_CLEAR:
	rcall ZEILE_15
	rcall ZEILE_CLEAR
	rjmp ZEILE_15
ZEILE_16_CLEAR:
	rcall ZEILE_16
	rcall ZEILE_CLEAR
	rjmp ZEILE_16
ZEILE_17_CLEAR:
	rcall ZEILE_17
	rcall ZEILE_CLEAR
	rjmp ZEILE_17
;-------------------------------------------------------------------------------
ZEILE_CLEAR:
	call ASCII_SPACE6
	call ASCII_SPACE6
	call ASCII_SPACE6
	jmp  ASCII_SPACE6
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEILE_0:
	ldi temp1,0 ; Spalte
	ldi temp2,0 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_1:
	ldi temp1,0 ; Spalte
	ldi temp2,1 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_2:
	ldi temp1,0 ; Spalte
	ldi temp2,2 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_3:
	ldi temp1,0 ; Spalte
	ldi temp2,3 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_4:
	ldi temp1,0 ; Spalte
	ldi temp2,4 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_5:
	ldi temp1,0 ; Spalte
	ldi temp2,5 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_6:
	ldi temp1,0 ; Spalte
	ldi temp2,6 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_7:
	ldi temp1,0 ; Spalte
	ldi temp2,7 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_8:
	ldi temp1,0 ; Spalte
	ldi temp2,8 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_9:
	ldi temp1,0 ; Spalte
	ldi temp2,9 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_10:
	ldi temp1,0  ; Spalte
	ldi temp2,10 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_11:
	ldi temp1,0  ; Spalte
	ldi temp2,11 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_12:
	ldi temp1,0  ; Spalte
	ldi temp2,12 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_13:
	ldi temp1,0  ; Spalte
	ldi temp2,13 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_14:
	ldi temp1,0  ; Spalte
	ldi temp2,14 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_15:
	ldi temp1,0  ; Spalte
	ldi temp2,15 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_16:
	ldi temp1,0  ; Spalte
	ldi temp2,16 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
ZEILE_17:
	ldi temp1,0  ; Spalte
	ldi temp2,17 ; ZEILE	
	rjmp CURSOR_POSITION_TEMP1_2
;-------------------------------------------------------------------------------
CURSOR_POSITION_TEMP1_2:
	WDR
	STS(adr_CURSOR_SPALTE),temp1
	STS(adr_CURSOR_ZEILE) ,temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_SPACE40:
	rcall ASCII_SPACE20
	rjmp  ASCII_SPACE20
ASCII_SPACE20:
	rcall ASCII_SPACE10
	rjmp  ASCII_SPACE10
ASCII_SPACE10:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE9:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE8:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE7:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE6:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE5:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE4:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE3:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE2:
	ldi temp,' '
	call ASCII_TEMP
ASCII_SPACE:
	ldi temp,' '
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PUNKT3:
	ldi temp,'.'
	call ASCII_TEMP
ASCII_PUNKT2:
	ldi temp,'.'
	call ASCII_TEMP
ASCII_PUNKT:
	ldi temp,'.'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_DOPPELPUNKT:
	ldi temp,':'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_KOMMA:
	ldi temp,','
	jmp ASCII_TEMP
; ##############################################################################
ASCII_GRD:
	ldi temp,0x07
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PLUS:
	ldi temp,'+'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_MINUS5:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS4:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS3:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS2:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_MINUS:
	ldi temp,'-'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_UNTERSTRICH2:
	ldi temp,'-'
	call ASCII_TEMP
ASCII_UNTERSTRICH:
	ldi temp,'-'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_SCHRAEGSTRICH:
	ldi temp,'/'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_FRAGEZEICHEN:
	ldi temp,'?'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_PROZENT:
	ldi temp,'%'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_0:
	ldi temp,'0'
	jmp ASCII_TEMP
ASCII_1:
	ldi temp,'1'
	jmp ASCII_TEMP
ASCII_2:
	ldi temp,'2'
	jmp ASCII_TEMP
ASCII_3:
	ldi temp,'3'
	jmp ASCII_TEMP
ASCII_4:
	ldi temp,'4'
	jmp ASCII_TEMP
ASCII_5:
	ldi temp,'5'
	jmp ASCII_TEMP
ASCII_6:
	ldi temp,'6'
	jmp ASCII_TEMP
ASCII_7:
	ldi temp,'7'
	jmp ASCII_TEMP
ASCII_8:
	ldi temp,'8'
	jmp ASCII_TEMP
ASCII_9:
	ldi temp,'9'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_A:
	ldi temp,'A'
	jmp ASCII_TEMP
ASCII_B:
	ldi temp,'B'
	jmp ASCII_TEMP
ASCII_C:
	ldi temp,'C'
	jmp ASCII_TEMP
ASCII_D:
	ldi temp,'D'
	jmp ASCII_TEMP
ASCII_E:
	ldi temp,'E'
	jmp ASCII_TEMP
ASCII_F:
	ldi temp,'F'
	jmp ASCII_TEMP
ASCII_G:
	ldi temp,'G'
	jmp ASCII_TEMP
ASCII_H:
	ldi temp,'H'
	jmp ASCII_TEMP
ASCII_I:
	ldi temp,'I'
	jmp ASCII_TEMP
ASCII_J:
	ldi temp,'J'
	jmp ASCII_TEMP
ASCII_K:
	ldi temp,'K'
	jmp ASCII_TEMP
ASCII_L:
	ldi temp,'L'
	jmp ASCII_TEMP
ASCII_M:
	ldi temp,'M'
	jmp ASCII_TEMP
ASCII_N:
	ldi temp,'N'
	jmp ASCII_TEMP
ASCII_O:
	ldi temp,'O'
	jmp ASCII_TEMP
ASCII_P:
	ldi temp,'P'
	jmp ASCII_TEMP
ASCII_Q:
	ldi temp,'Q'
	jmp ASCII_TEMP
ASCII_R:
	ldi temp,'R'
	jmp ASCII_TEMP
ASCII_S:
	ldi temp,'S'
	jmp ASCII_TEMP
ASCII_T:
	ldi temp,'T'
	jmp ASCII_TEMP
ASCII_U:
	ldi temp,'U'
	jmp ASCII_TEMP
ASCII_V:
	ldi temp,'V'
	jmp ASCII_TEMP
ASCII_W:
	ldi temp,'W'
	jmp ASCII_TEMP
ASCII_X:
	ldi temp,'X'
	jmp ASCII_TEMP
ASCII_Y:
	ldi temp,'Y'
	jmp ASCII_TEMP
ASCII_Z:
	ldi temp,'Z'
	jmp ASCII_TEMP
; ##############################################################################
ASCII_A_:
	ldi temp,'a'
	jmp ASCII_TEMP
ASCII_B_:
	ldi temp,'b'
	jmp ASCII_TEMP
ASCII_C_:
	ldi temp,'c'
	jmp ASCII_TEMP
ASCII_D_:
	ldi temp,'d'
	jmp ASCII_TEMP
ASCII_E_:
	ldi temp,'e'
	jmp ASCII_TEMP
ASCII_F_:
	ldi temp,'f'
	jmp ASCII_TEMP
ASCII_G_:
	ldi temp,'g'
	jmp ASCII_TEMP
ASCII_H_:
	ldi temp,'h'
	jmp ASCII_TEMP
ASCII_I_:
	ldi temp,'i'
	jmp ASCII_TEMP
ASCII_J_:
	ldi temp,'j'
	jmp ASCII_TEMP
ASCII_K_:
	ldi temp,'k'
	jmp ASCII_TEMP
ASCII_L_:
	ldi temp,'l'
	jmp ASCII_TEMP
ASCII_M_:
	ldi temp,'m'
	jmp ASCII_TEMP
ASCII_N_:
	ldi temp,'n'
	jmp ASCII_TEMP
ASCII_O_:
	ldi temp,'o'
	jmp ASCII_TEMP
ASCII_P_:
	ldi temp,'p'
	jmp ASCII_TEMP
ASCII_Q_:
	ldi temp,'q'
	jmp ASCII_TEMP
ASCII_R_:
	ldi temp,'r'
	jmp ASCII_TEMP
ASCII_S_:
	ldi temp,'s'
	jmp ASCII_TEMP
ASCII_T_:
	ldi temp,'t'
	jmp ASCII_TEMP
ASCII_U_:
	ldi temp,'u'
	jmp ASCII_TEMP
ASCII_V_:
	ldi temp,'v'
	jmp ASCII_TEMP
ASCII_W_:
	ldi temp,'w'
	jmp ASCII_TEMP
ASCII_X_:
	ldi temp,'x'
	jmp ASCII_TEMP
ASCII_Y_:
	ldi temp,'y'
	jmp ASCII_TEMP
ASCII_Z_:
	ldi temp,'z'
	jmp ASCII_TEMP
; ##############################################################################

