; ##############################################################################
; ##############################################################################
; ##############################################################################
BILD_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (TV_SYNC_DDR),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_DDR),(TV_DATA_PIN_NR)		; DATA	
	; auf HIGH								
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
	; auf LOW								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BILD_ON:
	rjmp BILD_INITIALISIERUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
BILD_OFF:
	; auf EINGANG							
	cbi (TV_SYNC_DDR),(TV_SYNC_PIN_NR)		; SYNC	
	cbi (TV_DATA_DDR),(TV_DATA_PIN_NR)		; DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ein DATENBYTE am PORT ausgeben (Schieberegister)								
.macro BILD_DATA_Z
	LD temp,Z+				; aus SRAM laden	
	OUT TV_DATA_PORT,temp	; BIT-0				
	LSR	temp				; 1 x rechts		
	NOP						; PAUSE				
	OUT TV_DATA_PORT,temp	; BIT-1				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-2				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-3				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-4				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-5				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-6				
	LSR	temp
	NOP
	OUT TV_DATA_PORT,temp	; BIT-7				
.endm
; ##############################################################################
.macro BILD_ZEILE_CHECK_Z
	LD temp,Z+
	OR temp1,temp
.endm
; ##############################################################################
.macro BILD_ZEILE_LEER_10
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
	rjmp BILD_ZEILE_LEER	; 
.endm
; ##############################################################################
.macro BILD_DATA_1
	rjmp BILD_DATA	; 1
.endm
; ##############################################################################
.macro BILD_DATA_10
	BILD_DATA_1	; 1
	BILD_DATA_1	; 2
	BILD_DATA_1	; 3
	BILD_DATA_1	; 4
	BILD_DATA_1	; 5
	BILD_DATA_1	; 6
	BILD_DATA_1	; 7
	BILD_DATA_1	; 8
	BILD_DATA_1	; 9
	BILD_DATA_1	; 10
.endm
; ##############################################################################
.macro BILD_DATA_100
	BILD_DATA_10	; 1
	BILD_DATA_10	; 2
	BILD_DATA_10	; 3
	BILD_DATA_10	; 4
	BILD_DATA_10	; 5
	BILD_DATA_10	; 6
	BILD_DATA_10	; 7
	BILD_DATA_10	; 8
	BILD_DATA_10	; 9
	BILD_DATA_10	; 10
.endm
; ##############################################################################
.macro BILD_DATA_256
	BILD_DATA_100
	BILD_DATA_100
	BILD_DATA_10
	BILD_DATA_10
	BILD_DATA_10
	BILD_DATA_10
	BILD_DATA_10
	BILD_DATA_1
	BILD_DATA_1
	BILD_DATA_1
	BILD_DATA_1
	BILD_DATA_1
	BILD_DATA_1
.endm
; ##############################################################################
.macro BILD_EXIT
	in temp,(TIFR0)	
	sbrc temp,1		
	LED_ROT_ON		
;-------------------------------------------------------------------------------
	OUT	SREG ,SREG_KOPIE		
	movw TEMP ,temp_KOPIE	; temp+temp1
	movw ZL,ZL_KOPIE 	; Copy Register Word
	reti
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 64s ms  TIMER																
; Alle 64 s muss eine TV-Zeile geschrieben werden								
;																				
TIM0_COMPA:
	in	SREG_KOPIE ,SREG		
	movw TEMP_KOPIE ,temp	; temp + temp1	
	movw ZL_KOPIE,ZL		; ZL   + ZH		
;-------------------------------------------------------------------------------
; TAKTKORREKTUR beim INTERRUPTAUFRUF, sonst jittert das TV-BILD					
	LDS temp,TCNT2		; Kontrolltimer auslesen	
	andi temp,0b00011111; 0...15					
	ldi ZL, LOW(TAKTKOREKTUR_SPRUNGMARKE)
	ldi ZH,HIGH(TAKTKOREKTUR_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	IJMP		; SPRUNG (Zeiger nach Z)
;-------------------------------------------------------------------------------
TAKTKOREKTUR_SPRUNGMARKE:
	nop	; 0
	nop	; 1
	nop	; 2
	nop	; 3
	nop	; 4
	nop	; 5
	nop	; 6
	nop	; 7
	nop	; 8
	nop	; 9
	nop	;10
	nop	;11
	nop	;12
	nop	;13
	nop	;14
	nop	;15
	nop	; 0
	nop	; 1
	nop	; 2
	nop	; 3
	nop	; 4
	nop	; 5
	nop	; 6
	nop	; 7
	nop	; 8
	nop	; 9
	nop	;10
	nop	;11
	nop	;12
	nop	;13
	nop	;14
	nop	;15
;-------------------------------------------------------------------------------
	; SOFORT SYNC L	/ 0 Volt				
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt
;-------------------------------------------------------------------------------
; Hier legen wir fest, wie jede einzelne Zeile (1..625) 						
; beschaffen ist, sieht zwar etwas seltsam aus, 								
; aber dafr werden immer die gleiche Anzahl von Takten bentigt und 			
; man erspart sich eine Menge Rechner- und Ausgleicherei.						
;																				
; Ein TV Bild besteht aus 625 Zeilen (BRUTTO).									
; Das erste Halbbild:         1...312,5 = 312,5 ZEILEN							
; Das zweite Halbbild:    312,5...625   = 312,5 ZEILEN							
;																				
; Nutzbare Zeilen:   	   23,5...310 	 = 287,5 ZEILEN							
;				     	    336...623,5 = 288,5	 ZEILEN							
;  																				
; TV-BILD: 320x256=81.920 PIXEL ---> :8=10.240 BYTE SRAM						
;																				
	;**********	 BILD erzeugen	**********	
	; ZEILENNUMMER +1						
	add TV_ZEILE_L,EINS
	adc TV_ZEILE_H,NULL
	; Z-ZEIGER initialisieren				
	mov ZL,TV_ZEILE_L
	mov ZH,TV_ZEILE_H
	ldi temp, LOW (BILDAUFBAU_SPRUNGMARKE)
	ldi temp1,HIGH(BILDAUFBAU_SPRUNGMARKE)
	add ZL,temp
	adc ZH,temp1
	IJMP		; SPRUNG (Zeiger nach Z)	
;-------------------------------------------------------------------------------
BILDAUFBAU_SPRUNGMARKE:
	; 1. Halbbild																
	rjmp BILD_HAUPTIMPULSE_INITIALISIERUNG 	;1 (HAUPTIMPULSE+INITIALISIERUNG)	
	rjmp BILD_HAUPTIMPULSE					;2 (HAUPTIMPULSE)				
	rjmp BILD_HAUPTIMPULS_NACHTRABANT_Z3	;3 (HAUPTIMPULS/NACHTRABANT)	
	rjmp BILD_TRABANTEN						;4 (TRABANTEN)					
	rjmp BILD_TRABANTEN						;5 (TRABANTEN)					
	BILD_ZEILE_LEER_10						;6 (Zeilen ohne INHALT)			
	BILD_ZEILE_LEER_10 						;16
	BILD_ZEILE_LEER_10						;26
	rjmp BILD_ZEILE_LEER 					;36
	rjmp BILD_ZEILE_LEER 					;37
	rjmp BILD_ZEILE_LEER 					;38
	rjmp BILD_ZEILE_LEER 					;39
	rjmp BILD_ZEILE_LEER 					;40
	rjmp BILD_ZEILE_LEER 					;41
	rjmp BILD_ZEILE_DIVERS 					;42	UHr + diverse Berechnungen
	rjmp BILD_DATA_INITIALISIERUNG			;43
	BILD_DATA_256							;44 (256 DATA-ZEILEN)		
	BILD_ZEILE_LEER_10						;300
	rjmp BILD_ZEILE_LEER 					;310
	rjmp BILD_TRABANTEN						;311 (TRABANTEN)					
	rjmp BILD_TRABANTEN						;312 (TRABANTEN)					
	; 2. Halbbild																
	rjmp BILD_TRABANT_HAUPTIMPULS_Z313		;313 (TRABANT/HAUPTIMPULS)	
	rjmp BILD_HAUPTIMPULSE					;314 (HAUPTIMPULSE)			
	rjmp BILD_HAUPTIMPULSE					;315 (HAUPTIMPULSE)			
	rjmp BILD_TRABANTEN						;316 (TRABANTEN)			
	rjmp BILD_TRABANTEN						;317 (TRABANTEN)			
	BILD_ZEILE_LEER_10						;318
	BILD_ZEILE_LEER_10 						;328
	BILD_ZEILE_LEER_10						;338
	rjmp BILD_ZEILE_LEER		 			;348
	rjmp BILD_ZEILE_LEER		 			;349
	rjmp BILD_ZEILE_LEER 					;350
	rjmp BILD_ZEILE_LEER 					;351
	rjmp BILD_ZEILE_LEER 					;352
	rjmp BILD_ZEILE_LEER 					;353
	rjmp BILD_ZEILE_LEER 					;354
	rjmp BILD_ZEILE_LEER 					;355
	rjmp BILD_DATA_INITIALISIERUNG			;356
	BILD_DATA_256							;357 (256 DATA-ZEILEN)		
	BILD_ZEILE_LEER_10						;613
	rjmp BILD_SYNCHRONIMPULS_TRABANT_Z623	;623 (SYNC+TRABANT)			
	rjmp BILD_TRABANTEN						;624 (TRABANTEN)			
	rjmp BILD_TRABANTEN						;625 (TRABANTEN)			
	rjmp BILD_HAUPTIMPULSE_INITIALISIERUNG 	;1 (HAUPTIMPULSE+INITIALISIERUNG)	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
; und ZEILENNUMMER-INITIALISIERUNG												
BILD_HAUPTIMPULSE_INITIALISIERUNG:
	; HAUPTIMPULS							
	rcall BILD_WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	call BILD_WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	call BILD_WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	; ZEILENNUMMER RESET					
	clr TV_ZEILE_L
	clr TV_ZEILE_H
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
BILD_HAUPTIMPULSE:
	; HAUPTIMPULS							
	rcall BILD_WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	call BILD_WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall BILD_WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-3																		
; HAUPTIMPULS / TRABANT															
BILD_HAUPTIMPULS_NACHTRABANT_Z3:
	; HAUPTIMPULS							
	rcall BILD_WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	call BILD_WAIT_4_7us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt / 2,35s		
	rcall BILD_WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TRABANTEN																		
BILD_TRABANTEN:
	; TRABANT								
	rcall BILD_WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	call BILD_WAIT_29_65us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/   0 Volt / 2,35s		
	rcall BILD_WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-313																		
; TRABANT + HAUPTIMPULS															
BILD_TRABANT_HAUPTIMPULS_Z313:
	; TRABANT								
	rcall BILD_WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	call BILD_WAIT_29_65us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt  /  29,65s	
	call BILD_WAIT_29_65us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-623																		
; SYNCHRONIMPULS + TRABANT														
BILD_SYNCHRONIMPULS_TRABANT_Z623:
	; SYNCHRONIMPULS						
	call BILD_WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; TRABANT								
	call BILD_WAIT_29_65us
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 2,35s		
	rcall BILD_WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile + diverse Aktionen												
; alle 40ms erfolgt Aufruf														
BILD_ZEILE_DIVERS:
	call BILD_WAIT_4_7us							; SYNCHRONIMPULS					
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
;-------------------------------------------------------------------------------
	LDS temp,(adr_USART_TIMER)
	cpi temp,(1+1)			; vergleich	
	brlo BILD_ZEILE_DIVERS_U
	dec temp				; -1		
	STS(adr_USART_TIMER),temp
BILD_ZEILE_DIVERS_U:
;-------------------------------------------------------------------------------
; UHR																			
	LDS temp,(adr_ss_VT); Vorteiler	
	dec temp
	tst temp
	brne BILD_ZEILE_DIVERS_VT
;-------------------------------------------------------------------------------
	call UHR_ss
	ldi temp,25			; Vorteiler
;-------------------------------------------------------------------------------
BILD_ZEILE_DIVERS_VT:
	STS(adr_ss_VT),temp
;-------------------------------------------------------------------------------
; Tasten Neustart/Reset															
	sbic (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp BILD_ZEILE_DIVERS_TASTEN
	sbic (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp BILD_ZEILE_DIVERS_TASTEN
	jmp PROGRAMM_NEUSTART
;-------------------------------------------------------------------------------
; Tasten_SPERRE																	
BILD_ZEILE_DIVERS_TASTEN:
	LDS temp,(adr_TASTEN_SPERRE)
	tst temp
	breq BILD_ZEILE_DIVERS_TASTEN_w
	dec temp
	STS(adr_TASTEN_SPERRE),temp
	rjmp BILD_ZEILE_DIVERS_EXIT	
;-------------------------------------------------------------------------------
; Tasten 																		
BILD_ZEILE_DIVERS_TASTEN_w:
	LDS temp,(adr_TASTE)
	tst temp
	brne BILD_ZEILE_DIVERS_EXIT
;-------------------------------------------------------------------------------
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)		; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_A)
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)		; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_B)
	sbis (TASTE_DG_PIN),(TASTE_DG_PIN_NR)	; springe, wenn BIT(PIN) high	
	SBR temp,(TASTE_DG)
	STS(adr_TASTE),temp						; save							
;-------------------------------------------------------------------------------
	tst temp 
	breq BILD_ZEILE_DIVERS_EXIT
	ldi temp,10
	STS(adr_TASTEN_SPERRE),temp
;-------------------------------------------------------------------------------
BILD_ZEILE_DIVERS_EXIT:
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben 															
BILD_ZEILE_LEER:
	; SYNCHRONIMPULS						
	call BILD_WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
;-------------------------------------------------------------------------------
; Drehgeber																		
	call DREH_ABFRAGEi
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben	und  DATA-RESET (ZEIGER auf DATENFELD)					
BILD_DATA_INITIALISIERUNG:
	; SYNCHRONIMPULS						
	call BILD_WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; DATA-RESET							
	ldi ZL, LOW (adr_TV_BILDBEREICH)
	ldi ZH, HIGH(adr_TV_BILDBEREICH)
	STS(adr_TV_ZEIGER_DATA_L),ZL
	STS(adr_TV_ZEIGER_DATA_H),ZH
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Eine TV-ZEILE schreiben														
; 45-Bytes (45x8=360PIXEL)														
BILD_DATA:
	; SYNCHRONIMPULS						
	call BILD_WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
;-----------------------------------------										
; hintere SCHWARZschulter 														
; Sie muss mindestens 5,8s betragen, bevor Bilddaten gesendet werden knnen.	
; Die Zeitvorgabe wird aber erfllt, durch den taktintensiven TV-ZEILEN-CHECK !	
;																				
; BILD positionieren (linker RAND)												
;	rcall wait_5_8us															
	LDS temp,(adr_TV_X_KORREKTUR)
BILD_DATA_POSITIONIEREN_s:
	dec temp
	brne BILD_DATA_POSITIONIEREN_s
;-----------------------------------------										
; TURBO-MODUS, liegen DATEN in der TV-Zeile vor?								
	LDS ZL,(adr_TV_ZEIGER_DATA_L)	; ZEIGER-DATA laden					
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	clr temp1
	BILD_ZEILE_CHECK_Z	
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z	; 10
	BILD_ZEILE_CHECK_Z	
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z	; 20
	BILD_ZEILE_CHECK_Z	
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z	; 30
	BILD_ZEILE_CHECK_Z	
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z
	BILD_ZEILE_CHECK_Z	; 40
	BILD_ZEILE_CHECK_Z	; 41
	BILD_ZEILE_CHECK_Z	; 42
	BILD_ZEILE_CHECK_Z	; 43
	BILD_ZEILE_CHECK_Z	; 44
	BILD_ZEILE_CHECK_Z	; 45
;-----------------------------------------										
	STS(adr_TV_ZEIGER_DATA_L),ZL			; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
	tst temp1
	brne BILD_DATA_RUN
	BILD_EXIT								; EXIT				
;-----------------------------------------										
; TV-ZEILE komplett schreiben													
BILD_DATA_RUN:
	sbiw ZL,45
	; jeweils ein DATENBYTE ausgeben	
	BILD_DATA_Z	; 1
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z	; 10
	BILD_DATA_Z	
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z	; 20
	BILD_DATA_Z	
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z	; 30
	BILD_DATA_Z	
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z
	BILD_DATA_Z	; 40
	BILD_DATA_Z	; 41
	BILD_DATA_Z	; 42
	BILD_DATA_Z	; 43
	BILD_DATA_Z ; 44
	BILD_DATA_Z	; 45
;-------------------------------------------------------------------------------
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	BILD_EXIT								; EXIT				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
.macro BILD_WAIT_1us
	nop ; 1	0,05 s
	nop ; 2	0,09 s
	nop ; 3	0,14 s
	nop ; 4	0,18 s
	nop ; 5	0,23 s
	nop ; 6	0,27 s
	nop ; 7	0,32 s
	nop ; 8	0,36 s
	nop ; 9	0,41 s
	nop ; 10	0,45 s
	nop ; 11	0,50 s
	nop ; 12	0,55 s
	nop ; 13	0,59 s
	nop ; 14	0,64 s
	nop ; 15	0,68 s
	nop ; 16	0,73 s
	nop ; 17	0,77 s
	nop ; 18	0,82 s
	nop ; 19	0,86 s
	nop ; 20	0,91 s
	nop ; 21	0,95 s
	nop ; 22	1,00 s
.endm
; ##############################################################################
.macro BILD_WAIT_2us
	BILD_WAIT_1us
	BILD_WAIT_1us
.endm
; ##############################################################################
.macro BILD_WAIT_10us
	BILD_WAIT_2us
	BILD_WAIT_2us
	BILD_WAIT_2us
	BILD_WAIT_2us
	BILD_WAIT_2us
.endm
; ##############################################################################
; ##############################################################################
; ##############################################################################
; rcall 4 TAKTE																	
; call  5 TAKTE																	
; ret   5 TAKTE																	
; 2,35s=51,7 Takte																
BILD_WAIT_2_35us:	; 4	
	BILD_WAIT_1us 	; (22 TAKTE)	
	nop 			; 1	
	nop 			; 2	
	nop 			; 3	
	nop 			; 4	
	nop 			; 5	
	nop 			; 6	
	nop 			; 7	
	nop 			; 8	
	nop 			; 9	
;	nop 			; 10
;	nop 			; 11
;	nop 			; 12
;	nop 			; 13
;	nop 			; 14
;	nop 			; 15
;	nop 			; 16
;	nop 			; 17
;	nop 			; 18
;	nop 			; 19
;	nop 			; 20
ret					; 5	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 4,75=104,5 Takte																
; nur 3s																		
BILD_WAIT_4_7us:	; 4	
	BILD_WAIT_1us 	; (22 TAKTE)	
	BILD_WAIT_1us 	; (22 TAKTE)	
	BILD_WAIT_1us 	; (22 TAKTE)	
	BILD_WAIT_1us 	; (22 TAKTE)	
;	nop 			; 1	
;	nop 			; 2	
;	nop 			; 3	
;	nop 			; 4	
;	nop 			; 5	
;	nop 			; 6	
;	nop 			; 7	
ret					; 5	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 27,3s=600,9 Takte															
BILD_wait_27_3us:		; 4	 
	BILD_WAIT_10us		; 220
	BILD_WAIT_10us		; 220
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_2us 		; 44 
;	NOP					; 1	
;	NOP					; 2	
;	NOP					; 3	
;	NOP					; 4	
;	NOP					; 5	
;	NOP					; 6	
;	NOP					; 7	
;	NOP					; 8	
;	NOP					; 9	
;	NOP					; 10
;	NOP					; 11
;	NOP					; 12
;	NOP					; 13
;	NOP					; 14
;	NOP					; 15
;	NOP					; 16
;	NOP					; 17
;	NOP					; 18
;	NOP					; 19
ret						; 5	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 29,65s=652,3																	
BILD_wait_29_65us:		; 4	 
	BILD_WAIT_10us		; 220
	BILD_WAIT_10us		; 220
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_2us 		; 44 
	BILD_WAIT_1us 		; 22 
;	NOP					; 1	
;	NOP					; 2	
;	NOP					; 3	
;	NOP					; 4	
;	NOP					; 5	
ret						; 5	
; ##############################################################################
; ##############################################################################
; ##############################################################################




