; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_LED:
	LDS temp,(adr_GPS_GSA_FIX_MODUS)
	cpi temp,1
	breq GPS_LED1
	cpi temp,2
	breq GPS_LED2
	cpi temp,3
	breq GPS_LED3
	LED_GRUEN_BIG_OFF
	LED_GELB_BIG_OFF
	LED_ROT_BIG_OFF
	ret
;-------------------------------------------------------------------------------
GPS_LED1:
	LED_GRUEN_BIG_OFF
	LED_GELB_BIG_OFF
	LED_ROT_BIG_ON
	ret
;-------------------------------------------------------------------------------
GPS_LED2:
	LED_GRUEN_BIG_OFF
	LED_GELB_BIG_ON
	LED_ROT_BIG_OFF
	ret
;-------------------------------------------------------------------------------
GPS_LED3:
	LED_GRUEN_BIG_ON
	LED_GELB_BIG_OFF
	LED_ROT_BIG_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_TEST:
	ldi ZH,high(GPS_TESTDATEN*2)	; TEXT 
	ldi ZL, low(GPS_TESTDATEN*2)

	ldi XL,low (adr_SD_DATA)
	ldi XH,high(adr_SD_DATA)
GPS_TEST_s:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	ST X+,temp
	tst temp  			
	brne GPS_TEST_s
;-------------------------------------------------------------------------------
	ldi ZL,low (adr_SD_DATA+7)
	ldi ZH,high(adr_SD_DATA+7)
	rcall GPS_CRC_Z_C
	brcc GPS_TEST_ERROR
	ret
;-------------------------------------------------------------------------------
GPS_TEST_ERROR:
	call GRAFIC_CLEAR	
	call TEXT_PROGRAMM
	call TEXT_CRC
	call TEXT_ERROR
	call BEEP_LANG
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alte Daten NULL																
GPS_BEREINIGEN:
	LDS ZL,(adr_USART_ZEIGER_L)
	LDS ZH,(adr_USART_ZEIGER_H)
	ldi XL,low (adr_GPS_BUFFER)
	ldi XH,high(adr_GPS_BUFFER)
	sub ZL,XL
	sbc ZH,XH
	STS(adr_USART_BYTES_L),ZL		; Anzahl USART Bytes
	STS(adr_USART_BYTES_H),ZH
;-------------------------------------------------------------------------------
	cpi ZH,high(512+1)
	brlo GPS_BEREINIGEN_w
	breq GPS_BEREINIGEN_WAL
	brsh GPS_BEREINIGEN_WA
GPS_BEREINIGEN_WAL:
	cpi ZL,low (512+1)
	brlo GPS_BEREINIGEN_w
	breq GPS_BEREINIGEN_w
GPS_BEREINIGEN_WA:
	ldi temp,(ERROR_512)
	call WARNUNG_SAVE_TEMP
;-------------------------------------------------------------------------------
GPS_BEREINIGEN_w:
	LDS XL,(adr_USART_BYTES_MAX_L)
	LDS XH,(adr_USART_BYTES_MAX_H)
	cp ZH,XH
	brlo GPS_BEREINIGEN_w2
	breq GPS_BEREINIGEN_L
	brsh GPS_BEREINIGEN_MAX
GPS_BEREINIGEN_L:	
	cp ZL,XL
	brlo GPS_BEREINIGEN_w2
	breq GPS_BEREINIGEN_w2
GPS_BEREINIGEN_MAX:
	STS(adr_USART_BYTES_MAX_L),ZL	; Anzahl USART Bytes(max)
	STS(adr_USART_BYTES_MAX_H),ZH
;-------------------------------------------------------------------------------
GPS_BEREINIGEN_w2:
	LDS ZL,(adr_USART_ZEIGER_L)
	LDS ZH,(adr_USART_ZEIGER_H)
;-------------------------------------------------------------------------------
GPS_BEREINIGEN_s:
	LD temp,Z
	tst temp
	breq GPS_BEREINIGEN_EXIT
	ST Z+,NULL
	rjmp GPS_BEREINIGEN_s
;-------------------------------------------------------------------------------
GPS_BEREINIGEN_EXIT:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BUFFER kopieren																
GPS_COPY:
	ldi ZL,low (adr_GPS_BUFFER)
	ldi ZH,high(adr_GPS_BUFFER)
	ldi XL,low (adr_SD_DATA)
	ldi XH,high(adr_SD_DATA)
GPS_COPY_S:	
	LD temp,Z+
	ST X+,temp
	cpi ZL,low (adr_GPS_BUFFER+GPS_BUFFER_LEN)
	brne GPS_COPY_S
	cpi ZH,high(adr_GPS_BUFFER+GPS_BUFFER_LEN)
	brne GPS_COPY_S
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; gesamten Dtenbereich lschen													
GPS_CLEAR:
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
GPS_CLEAR_s:	
	ST Z+,NULL
	cpi ZL,low (adr_SD_DATA+GPS_BUFFER_LEN)
	brne GPS_CLEAR_s
	cpi ZH,high(adr_SD_DATA+GPS_BUFFER_LEN)
	brne GPS_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; $GPGGA,hhmmss.ss,llll.ll,a,yyyyy.yy,a,x,xx,x.x,x.x,M,x.x,M,x.x,xxxx*hh		
; 1 = UTC of Position															
; 2 = Latitude																	
; 3 = N or S																	
; 4 = Longitude																	
; 5 = E or W																	
; 6 = GPS quality indicator (0=invalid; 1=GPS fix; 2=Diff. GPS fix)				
; 7 = Number of satellites in use [not those in view]							
; 8 = Horizontal dilution of position											
; 9 = Antenna altitude above/below mean sea level (geoid)						
; 10 = Meters (Antenna height unit)												
; 11 = Geoidal separation (Diff. between WGS-84 earth ellipsoid and mean sea level. -=geoid is below WGS-84 ellipsoid)
; 12 = Meters (Units of geoidal separation)										
; 13  = Age in seconds since last update from diff. reference station			
; 14 = Diff. reference station ID#												
; 15 = Checksum																	
; $GPGGA,194524.094,,,,,0,00,,,M,,M,,*7A										
GPS_GGA:
	ldi temp1,'G'
	ldi temp2,'G'
	ldi temp3,'A'
	rcall GPS_SEARCH_TEMP1_2_3_Z_C
	brcs GPS_GGA_RUN
	ret
;-------------------------------------------------------------------------------
GPS_GGA_RUN:						; 1 = UTC of Position
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 2 = Latitude																	
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3 = N or S																	
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 4 = Longitude																	
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 5 = E or W																	
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 6 = GPS quality indicator (0=invalid; 1=GPS fix; 2=Diff. GPS fix)				
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 7 = Number of satellites in use [not those in view]							
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GGA_SAT_USE),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 8 = Horizontal dilution of position											
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 9 = Antenna altitude above/below mean sea level (geoid)						
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 10 = Meters (Antenna height unit)												
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 11 = Geoidal separation (Diff. between WGS-84 earth ellipsoid and mean sea level. -=geoid is below WGS-84 ellipsoid)
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 12 = Meters (Units of geoidal separation)										


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; $GPRMC,220516,A,5133.82,N,00042.24,W,173.8,231.8,130694,004.2,W*70			
;        1      2 3       4 5        6 7     8     9      10    11 12			
;        
; 1 = UTC of position fix
; 2 = Data status (V=navigation receiver warning)
; 3 = Latitude of fix
; 4 = N or S
; 5 = Longitude of fix
; 6 = E or W
; 7 = Speed over ground in knots
; 8 = Track made good in degrees True
; 9 = UT date
; 10 = Magnetic variation degrees (Easterly var. subtracts from true course)
; 11 = E or W
; 12 = Checksum
;$GPRMC,194525.094,V,,,,,0.00,0.00,191219,,,N*4D								
GPS_RMC:
	ldi temp1,'R'
	ldi temp2,'M'
	ldi temp3,'C'
	rcall GPS_SEARCH_TEMP1_2_3_Z_C
	brcs GPS_RMC_RUN
	ret
;-------------------------------------------------------------------------------
GPS_RMC_RUN:						; 1 = UTC of position fix
	rcall GPS_DEZ2_Z_TEMP1			; ZEIT	
	STS(adr_GPS_hh),temp1
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_mm),temp1
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_ss),temp1
;-------------------------------------------------------------------------------
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 2 = Data status (V=navigation receiver warning)
	LD temp,Z+
	STS(adr_GPS_RMC_WARNUNG),temp		; A/V
;-------------------------------------------------------------------------------
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3 = Latitude of fix
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 4 = N or S
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 5 = Longitude of fix
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 6 = E or W
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 7 = Speed over ground in knots
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 8 = Track made good in degrees True
;-------------------------------------------------------------------------------
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 9 = UT date
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_TAG),temp1
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_MONAT),temp1
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_JAHR),temp1
;-------------------------------------------------------------------------------
	LDS temp,(adr_UHR_SYNCHRONISIEREN)
	tst temp
	brne GPS_RMC_UHR
	ret
;-------------------------------------------------------------------------------
GPS_RMC_UHR:
	LDS temp,(adr_GPS_JAHR)
	cpi temp,20
	brsh GPS_RMC_UHR_w
	ret
;-------------------------------------------------------------------------------
GPS_RMC_UHR_w:
	STS(adr_UHR_SYNCHRONISIEREN),NULL

	LDS temp3,(adr_GPS_hh)
	LDS temp2,(adr_GPS_mm)
	LDS temp1,(adr_GPS_ss)

	LDS temp,(adr_UTC)
	add temp3,temp
	cpi temp3,24
	brlo GPS_RMC_w
	subi temp3,24
GPS_RMC_w:
	STS(adr_hh),temp3
	STS(adr_mm),temp2
	STS(adr_ss),temp1


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; GPS DOP and active satellites													
; $GPGSA,A,3,,,,,,16,18,,22,24,,,3.6,2.1,2.2*3C									
; $GPGSA,A,3,19,28,14,18,27,22,31,39,,,,,1.7,1.0,1.3*35							
; 1 = Mode:  M=Manual, forced to operate in 2D or 3D  A=Automatic, 3D/2D		
; 2 = Mode: 1=Fix not available 2=2D 3=3D										
; 3-14 = IDs of SVs used in position fix (null for unused fields)				
; 15 = PDOP																		
; 16 = HDOP																		
; 17 = VDOP																		
GPS_GSA:
	ldi temp1,'G'
	ldi temp2,'S'
	ldi temp3,'A'
	rcall GPS_SEARCH_TEMP1_2_3_Z_C
	brcs GPS_GSA_RUN
	ret
;-------------------------------------------------------------------------------
GPS_GSA_RUN:						; 1 = Mode:  M=Manual, forced to operate in 2D or 3D  A=Automatic, 3D/2D		
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 2 = Mode: 1=Fix not available 2=2D 3=3D										
	LD temp,Z+
	subi temp,(48)
	STS(adr_GPS_GSA_FIX_MODUS),temp
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID0),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID1),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID2),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID3),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID4),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID5),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID6),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID7),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID8),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID9),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID10),temp1
	rcall GPS_SEARCH_NEXT_KOMMA_Z	; 3-14 = IDs of SVs used in position fix (null for unused fields)				
	rcall GPS_DEZ2_Z_TEMP1
	STS(adr_GPS_GSA_ID11),temp1
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 = Total number of messages of this type in this cycle						
; 2 = Message number															
; 3 = Total number of SVs in view												
; 4 = SV PRN number																
; 5 = Elevation in degrees, 90 maximum											
; 6 = Azimuth, degrees from true north, 000 to 359								
; 7 = SNR, 00-99 dB (null when not tracking)									
; 8-11 = field 4-7																
; 12-15= field 4-7																
; 16-19= field 4-7																
; 																				
; $GPGSV,1,1,01,06,,,31*7C														
; $GPGSV,4,1,14,24,87,259,25,12,57,240,26,19,47,078,38,17,34,053,41*77			
; $GPGSV,4,2,14,36,28,154,36,15,27,185,24,32,18,318,28,25,16,244,16*76			
; $GPGSV,4,3,14,10,14,282,16,13,08,159,27,06,06,105,13,28,05,060,12*7E			
; $GPGSV,4,4,14,20,03,255,,01,02,006,20*78										
; 																				
GPS_GSV_C:
	ldi temp1,'G'
	ldi temp2,'S'
	ldi temp3,'V'
	rcall GPS_SEARCH_TEMP1_2_3_Z_C
	brcs GPS_GSV_RUN
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
GPS_GSV_RUN:
	rcall GPS_GSV_DATA_CLEAR
;-------------------------------------------------------------------------------
	adiw ZL,4
	rcall GPS_DEZ2_Z_TEMP1			; 3 = Total number of SVs in view												
	STS(adr_GPS_GSV_SAT_VIEW),temp1
	LDS temp,(adr_GPS_GSV_SAT_VIEW_MAX); max
	cp temp,temp1
	brsh GPS_GSV_w
	STS(adr_GPS_GSV_SAT_VIEW_MAX),temp1; max
GPS_GSV_w:
;-------------------------------------------------------------------------------
; $GPGSV,,1																		
	ldi XL,low (adr_GPS_GSV_DATA)	; X	
	ldi XH,high(adr_GPS_GSV_DATA)
	rcall GPS_GSV_DATENSATZ
;-------------------------------------------------------------------------------
; $GPGSV,,...																	
GPS_GSV_NEXT:
	LD temp,Z+
	tst temp
	brne GPS_GSV_2w
	SEC 		; Set Carry
	ret
;-------------------------------------------------------------------------------
GPS_GSV_2w:
	cpi temp,'G'
	brne GPS_GSV_NEXT
	LD temp,Z+
	cpi temp,'S'
	brne GPS_GSV_NEXT
	LD temp,Z+
	cpi temp,'V'
	brne GPS_GSV_NEXT
	adiw ZL,7
	rcall GPS_GSV_DATENSATZ
	rjmp GPS_GSV_NEXT
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
GPS_GSV_DATENSATZ:
	ldi temp9,4				; Schleife	
GPS_GSV_DATENSATZ_s1:
	rcall GPS_GSV_DATA_C
	brcs GPS_GSV_DATENSATZ_D0
	ret
;-------------------------------------------------------------------------------
GPS_GSV_DATENSATZ_D0:
	rcall GPS_DEZ2_Z_TEMP1	; 4 = SV PRN number									
	ST X+,temp1

	ldi YL,low (adr_GPS_STATISTIK)
	ldi YH,high(adr_GPS_STATISTIK)
	add YL,temp1
	adc YH,NULL
	ST Y,temp1

	rcall GPS_GSV_DATA_C
	brcs GPS_GSV_DATENSATZ_D1
	ret
;-------------------------------------------------------------------------------
GPS_GSV_DATENSATZ_D1:
	rcall GPS_DEZ2_Z_TEMP1	; 5 = Elevation in degrees, 90 maximum				
	ST X+,temp1
	rcall GPS_GSV_DATA_C
	brcs GPS_GSV_DATENSATZ_D2
	ret
;-------------------------------------------------------------------------------
GPS_GSV_DATENSATZ_D2:
	rcall GPS_DEZ3_Z_TEMP1_2; 6 = Azimuth, degrees from true north, 000 to 359	
	ST X+,temp1
	ST X+,temp2
	rcall GPS_GSV_DATA_C
	brcs GPS_GSV_DATENSATZ_D3
	ret
;-------------------------------------------------------------------------------
GPS_GSV_DATENSATZ_D3:
	rcall GPS_DEZ2_Z_TEMP1	; 7 = SNR, 00-99 dB (null when not tracking)		
	ST X+,temp1
;-------------------------------------------------------------------------------
	dec temp9
	brne GPS_GSV_DATENSATZ_s1
ret
;-------------------------------------------------------------------------------
GPS_GSV_DATA_C:
	LD temp,Z+
	tst temp
	breq GPS_GSV_DATA_NOT_FOUND
	cpi temp,'*'
	breq GPS_GSV_DATA_NOT_FOUND
	cpi temp,','
	brne GPS_GSV_DATA_C
	SEC 		; Set Carry
ret
;-------------------------------------------------------------------------------
GPS_GSV_DATA_NOT_FOUND:
	CLC 		; Clear Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_GSV_DATA_CLEAR:
	ldi XL,low (adr_GPS_GSV_DATA)	; alte Daten lschen
	ldi XH,high(adr_GPS_GSV_DATA)
	ldi temp9,(5*16)
GPS_GSV_DATA_CLEAR_s:	
	ST X+,NULL
	dec temp9
	brne GPS_GSV_DATA_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 01.01.00:00= 0																
; 01.01.00:10=10																
; 1 Tag = 60*24   =   1.440 Min													
; 1 Jahr=60*24*366= 527.040 Min													
;																				
; SEKTOR=0 dann Carry clear														
GPS_CALC_SD_SEKTOR_C:
	clr SEKTOR0
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
;-------------------------------------------------------------------------------
	LDS temp,(adr_GPS_MONAT)
	tst temp
	brne GPS_CALC_SD_RUN
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
; vergangene Monate in MINUTEN													
GPS_CALC_SD_RUN:
	LDS temp,(adr_GPS_MONAT)
	cpi temp,12
	breq GPS_CALC_11
	cpi temp,11
	breq GPS_CALC_10
	cpi temp,10
	breq GPS_CALC_09
	cpi temp,9
	breq GPS_CALC_08
	cpi temp,8
	breq GPS_CALC_07
	cpi temp,7
	breq GPS_CALC_06
	cpi temp,6
	breq GPS_CALC_05
	cpi temp,5
	breq GPS_CALC_04
	cpi temp,4
	breq GPS_CALC_03
	cpi temp,3
	breq GPS_CALC_02
	cpi temp,2
	breq GPS_CALC_01
	rjmp GPS_CALC_00
;-------------------------------------------------------------------------------
GPS_CALC_11:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_10:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_09:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_08:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_07:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_06:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_05:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_04:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_03:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_02:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_01:
	ldi temp1,low (60*24*31)
	ldi temp2,high(60*24*31)
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
GPS_CALC_00:
;-------------------------------------------------------------------------------
; Tag des Monats in MINUTEN														
	LDS temp9,(adr_GPS_TAG)
	cpi temp9,1
	breq GPS_CALC_SD_SEKTOR_hh
	dec temp9
	ldi temp1,low (60*24)
	ldi temp2,high(60*24)
GPS_CALC_SD_SEKTOR_s:
	add SEKTOR0,temp1
	adc SEKTOR1,temp2
	adc SEKTOR2,NULL
	dec temp9
	brne GPS_CALC_SD_SEKTOR_s
;-------------------------------------------------------------------------------
; Stunden in MINUTEN															
GPS_CALC_SD_SEKTOR_hh:
	LDS temp,(adr_GPS_HH)
	ldi temp5,60
	mul temp,temp5
	add SEKTOR0,R0
	adc SEKTOR1,R1
	adc SEKTOR2,NULL
;-------------------------------------------------------------------------------
; MINUTE																		
	LDS temp,(adr_GPS_mm)
	add SEKTOR0,temp
	adc SEKTOR1,NULL
	adc SEKTOR2,NULL
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;$GPRMC,																		
GPS_SEARCH_TEMP1_2_3_Z_C:
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
;-------------------------------------------------------------------------------
GPS_SEARCH_s:
	LD temp,Z
	tst temp
	breq GPS_SEARCH_NOT_FOUND
;-------------------------------------------------------------------------------
GPS_SEARCH_w:
	LD temp,Z+			; read	
	cpi temp,'$'		; $		
	brne GPS_SEARCH_s 	
	LD temp,Z+			; read	
	cpi temp,'G'		; G		
	brne GPS_SEARCH_s 
	LD temp,Z+			; read	
	cpi temp,'P'		; P		
	brne GPS_SEARCH_s 
	LD temp,Z+			; read	
	cp temp,temp1		; temp1	
	brne GPS_SEARCH_s 	
	LD temp,Z+			; read	
	cp temp,temp2		; temp2	
	brne GPS_SEARCH_s 
	LD temp,Z+			; read	
	cp temp,temp3		; temp3	
	brne GPS_SEARCH_s 
	adiw ZL,1			; Z+1	
	rcall GPS_CRC_Z_C	; CRC	
	brcc GPS_SEARCH_NOT_FOUND
	SEC 				; Set Carry
ret	
;-------------------------------------------------------------------------------
GPS_SEARCH_NOT_FOUND:
	CLC 				; Clear Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;$GPRMC,																		
; CRC berechnen																	
; OUT: Carry																	
GPS_CRC_Z_C:
	push ZL
	push ZH
	sbiw ZL,6
	clr temp1
;-------------------------------------------------------------------------------
GPS_CRC_s1:
	LD temp,Z+
	cpi temp,'*'	; Ende		
	breq GPS_CRC_w
	tst temp		; berlauf	
	breq GPS_CRC_ERROR
	eor temp1,temp
	rjmp GPS_CRC_s1
;-------------------------------------------------------------------------------
GPS_CRC_w:
	STS(adr_GPS_CRC),temp1
	rcall GPS_CRC_DEZ_HEX_Z_TEMP1
	LDS temp2,(adr_GPS_CRC)
	cp temp1,temp2
	brne GPS_CRC_ERROR
	pop ZH
	pop ZL
	SEC 				; Set Carry		
ret
;-------------------------------------------------------------------------------
GPS_CRC_ERROR:
	ldi temp,(ERROR_CRC); Error			
	call ERROR_SAVE_TEMP
	LED_ROT_ON
	pop ZH
	pop ZL
	CLC 				; Clear Carry	
ret
;-------------------------------------------------------------------------------
GPS_CRC_DEZ_HEX_Z_TEMP1:
	LD temp,Z+	
	rcall GPS_CRC_DEZ_HEX
	SWAP temp
	mov temp1,temp
	LD temp,Z+	
	rcall GPS_CRC_DEZ_HEX
	add temp1,temp
	ret
;-------------------------------------------------------------------------------
GPS_CRC_DEZ_HEX:
	cpi temp,'9'+1
	brlo GPS_CRC_DEZ_HEX_L
	subi temp,('A')-10
	ret
GPS_CRC_DEZ_HEX_L:
	subi temp,('0')
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_SEARCH_NEXT_KOMMA_Z:
	LD temp,Z+
	tst temp
	brne GPS_SEARCH_NEXT_KOMMA_w
	ret
;-------------------------------------------------------------------------------
GPS_SEARCH_NEXT_KOMMA_w:
	cpi temp,','
	brne GPS_SEARCH_NEXT_KOMMA_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_DEZ2_Z_TEMP1:
	LD temp,Z
	cpi temp,','
	breq GPS_DEZ2_ERROR
	cpi temp,'*'
	breq GPS_DEZ2_ERROR
	rjmp GPS_DEZ2_w
;-------------------------------------------------------------------------------
GPS_DEZ2_ERROR:
	clr temp1
	ret
;-------------------------------------------------------------------------------
GPS_DEZ2_w:
	LD temp2,Z+
	subi temp2,(48)		; ASC-->BIN	
	ldi temp,10
	mul temp2,temp
	mov temp2,R0
	LD temp1,Z+
	subi temp1,(48)		; ASC-->BIN	
	add temp1,temp2	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
GPS_DEZ3_Z_TEMP1_2:
	LD temp,Z
	cpi temp,','
	brne GPS_DEZ3_w
	clr temp1
	clr temp2
	ret
;-------------------------------------------------------------------------------
GPS_DEZ3_w:
	LD temp3,Z+
	subi temp3,(48)		; ASC-->BIN	
	ldi temp,100
	mul temp,temp3
	mov temp1,R0
	mov temp2,R1


	LD temp3,Z+
	subi temp3,(48)		; ASC-->BIN	
	ldi temp,10
	mul temp,temp3
	add temp1,R0
	adc temp2,R1

	LD temp3,Z+
	subi temp3,(48)		; ASC-->BIN	
	add temp1,temp3
	adc temp2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
