; ##############################################################################
; ##############################################################################
; ##############################################################################
; Setzt oder lscht einen Punkt an den Koordinaten X,Y							
;																				
; INP:																			
;	X(links unten: X=0 	Y=0)	(Bereich: 0...359)								
;	Y(rechts oben: X=319 Y=255)	(Bereich: 0...255)								
;																				
; REGISTER:																		
;(nicht gesichert !!! wegen Zeitersparnis)										
; 	R0+R1+R2+R3+R4+R5															
; 	temp+ZL+ZH																	
;																				
GRAFIC_PUNKT_X_Y:
	; PUNKTGROESSE		
	LDS R5,(adr_GRAFIC_PUNKT_GROESSE)
	tst R5
	breq GRAFIC_PUNKT_START
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_R5
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Y im Bereich ? 																
GRAFIC_PUNKT_START:
	tst YH						; berlauf ?	
	breq GRAFIC_PUNKT_Y_OK
	ret							; zurck 
;-------------------------------------------------------------------------------
; X im BEREICH ? 																
GRAFIC_PUNKT_Y_OK:
	cpi XH,HIGH(XSITZE-1)	; berlauf ?	
	brlo GRAFIC_PUNKT_X_OK
	breq GRAFIC_PUNKT_X_L
	ret							; zurck 
GRAFIC_PUNKT_X_L:
	cpi XL,LOW (XSITZE-1)	; berlauf ?	
	brlo GRAFIC_PUNKT_X_OK
	breq GRAFIC_PUNKT_X_OK
	ret							; zurck 
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_X_OK:
	push ZL
	push ZH
	; GRAFIC-SPALTE auf unten-links setzen					
	ldi ZL, LOW (adr_TV_BILDBEREICH_ENDE-44)
	ldi ZH, HIGH(adr_TV_BILDBEREICH_ENDE-44)
	; GRAFIC-SPALTE vorbereiten								
	mov R0,XL
	mov R1,XH
	LSR R1		; :2(2)
	ROR R0
	LSR R1		; :2(4)
	ROR R0
	LSR R1		; :2(8)
	ROR R0
	; GRAFIC-SPALTE bestimmen								
	add ZL,R0
	adc ZH,R1
	; GRAFIC-ZEILE vorbereiten	(Y mal 45BYTE)				
	ldi temp,45
	MUL YL,temp			; Ergebnis in R0+R1
	; GRAFIC-SPALTE und GRAFIC-ZEILE vereinen... fertsch !									
	; Nun ist uns bekannt, welche SRAM-Adresse (Z) ausgelesen werden muss					
	sub ZL,R0
	sbc ZH,R1
	; Hier lesen wir das SRAM-BYTE aus(Z) und befummeln anschlieend das entsprechende BIT	
	LD R0,Z
	; Nun mssen wir nur noch herausfinden, welche BIT-Position  es betrifft,				
	; geht auch mit einer Tabelle, dauert aber lnger										
	mov temp,XL
	andi temp,0b00000111
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_0:
	cpi temp,0
	brne GRAFIC_PUNKT_1	; vergleich		
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_0_CLEAR
	ldi temp,0b00000001	; Bitmuster		
	or R0,temp			; verknpfen 	
	ST Z,R0				; SRAM write	
	pop ZH
	pop ZL
	ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_0_CLEAR:
	ldi temp,0b11111110	; Bitmuster		
	and R0,temp			; verknpfen 	
	ST Z,R0				; SRAM write	
	pop ZH
	pop ZL
	ret
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_1:
	cpi temp,1
	brne GRAFIC_PUNKT_2
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_1_CLEAR
	ldi temp,0b00000010	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_1_CLEAR:
	ldi temp,0b11111101
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_2:
	cpi temp,2
	brne GRAFIC_PUNKT_3
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_2_CLEAR
	ldi temp,0b00000100	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_2_CLEAR:
	ldi temp,0b11111011
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_3:
	cpi temp,3
	brne GRAFIC_PUNKT_4
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_3_CLEAR
	ldi temp,0b00001000	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_3_CLEAR:
	ldi temp,0b11110111
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_4:
	cpi temp,4
	brne GRAFIC_PUNKT_5
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_4_CLEAR
	ldi temp,0b00010000	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_4_CLEAR:
	ldi temp,0b11101111
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_5:
	cpi temp,5
	brne GRAFIC_PUNKT_6
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_5_CLEAR
	ldi temp,0b00100000	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_5_CLEAR:
	ldi temp,0b11011111
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_6:
	cpi temp,6
	brne GRAFIC_PUNKT_7
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_6_CLEAR
	ldi temp,0b01000000	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_6_CLEAR:
	ldi temp,0b10111111
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
;-------------------------------------------------------------------------------
GRAFIC_PUNKT_7:
	LDS R1,(adr_GRAFIC_FARBE)
	SBRC R1,0		; Skip if...
	rjmp GRAFIC_PUNKT_7_CLEAR
	ldi temp,0b10000000	; 
	or R0,temp
	ST Z,R0
	pop ZH
	pop ZL
	ret
GRAFIC_PUNKT_7_CLEAR:
	ldi temp,0b01111111
	and R0,temp			
	ST Z,R0
	pop ZH
	pop ZL
	ret				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REGISTER:																		
;			R5																	
GRAFIC_PUNKT_X_Y_GROESSE_R5:
	; MITTELPUNKT					
	rcall GRAFIC_PUNKT_START	; PUNKT setzen	
	mov temp,R5
GRAFIC_PUNKT_X_Y_GROESSE_1w:	
	cpi temp,1
	brne GRAFIC_PUNKT_X_Y_GROESSE_2w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_1
GRAFIC_PUNKT_X_Y_GROESSE_2w:
	cpi temp,2
	brne GRAFIC_PUNKT_X_Y_GROESSE_3w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_2
GRAFIC_PUNKT_X_Y_GROESSE_3w:
	cpi temp,3
	brne GRAFIC_PUNKT_X_Y_GROESSE_4w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_3
GRAFIC_PUNKT_X_Y_GROESSE_4w:
	cpi temp,4
	brne GRAFIC_PUNKT_X_Y_GROESSE_5w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_4
GRAFIC_PUNKT_X_Y_GROESSE_5w:
	cpi temp,5
	brne GRAFIC_PUNKT_X_Y_GROESSE_6w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_5
GRAFIC_PUNKT_X_Y_GROESSE_6w:
	cpi temp,6
	brne GRAFIC_PUNKT_X_Y_GROESSE_7w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_6
GRAFIC_PUNKT_X_Y_GROESSE_7w:
	cpi temp,7
	brne GRAFIC_PUNKT_X_Y_GROESSE_8w
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_7
GRAFIC_PUNKT_X_Y_GROESSE_8w:
	cpi temp,8
	brne GRAFIC_PUNKT_X_Y_GROESSE_9
	rjmp GRAFIC_PUNKT_X_Y_GROESSE_8
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_9:
	sbiw XL,8	; X-8
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_START	;1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;3
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;5
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;6
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;7
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;8
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;9
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;11
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;13
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;14
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;15
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;16
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;17
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;18
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;19
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;20
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;21
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;22
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;23
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;24
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;25
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;26
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;27
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;28
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;29
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;30
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;31
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;32
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	;33
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;34
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;35
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;36
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;37
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;38
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;39
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;40
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;41
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;42
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;43
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;44
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;45
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;46
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;47
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;48
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	;49
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;50
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;51
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;52
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;53
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;54
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;55
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;56
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;57
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;58
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;59
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;60
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;61
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	;62
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;63
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	;64
	adiw XL,7	; X+7	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_8:
	sbiw XL,7	; X-7
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 6A
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 14A
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 22A
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 30A
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 32
	adiw XL,6	; X+6	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_7:
	sbiw XL,6	; X-6
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 2
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 3
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 4
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 5
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 6
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 7
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 8
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 9
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 10
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 11
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 12
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 13
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 14
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 15
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 16
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 17
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 18
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 19
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 20
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 21
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 22
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 23
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 24
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 25
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 26
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 27
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 28
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 29
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 30
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 31
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 32
	adiw XL,5	; X+5	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_6:
	sbiw XL,5	; X-5
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,4	; X+4	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_5:
	sbiw XL,4	; X-4
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,3	; X+3	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_4:
	sbiw XL,3	; X-3
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START	; 
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START	; 
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START	; 
	adiw XL,2	; X+2	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_3:
	sbiw XL,2	; X-2
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw YL,1	; Y+1
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw YL,1	; Y-1
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
	adiw YL,2	; Y+2
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_2:
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	adiw YL,2	; Y+2
	rcall GRAFIC_PUNKT_START
	adiw XL,2	; X+2
	rcall GRAFIC_PUNKT_START
	sbiw YL,2	; Y-2
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
;----------------------------------------------------------------------------------------------------
GRAFIC_PUNKT_X_Y_GROESSE_1:
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	sbiw YL,1	; Y-1
	rcall GRAFIC_PUNKT_START
	sbiw XL,1	; X-1
	adiw YL,1	; Y+1
	rcall GRAFIC_PUNKT_START
	adiw XL,1	; X+1	 wieder auf MITTELPUNKT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
