; ##############################################################################
; ##############################################################################
; ##############################################################################
; CS02 CS01 CS00																
;	0 	0	0 	No clock source (Timer/Counter stopped)							
;	0 	0 	1 	clkI/O/(No prescaling)											
; *	0 	1 	0 	clkI/O/8 (From prescaler)										
;	0 	1 	1 	clkI/O/64 (From prescaler)										
;	1 	0 	0 	clkI/O/256 (From prescaler)										
;	1 	0 	1 	clkI/O/1024 (From prescaler)									
;	1 	1 	0 	External clock source on T0 pin. Clock on falling edge.			
;	1 	1 	1 	External clock source on T0 pin. Clock on rising edge.			
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; *	2 	0 	1 	 0 		CTC														
; 	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
; 8-BIT-TIMER																	
; 64s TIMER																	
; 1/64s=15625																	
TIMER0_INITIALISIERUNG_CTC_64us:
.equ TIMER0_CTC_FREQUENZ					= 15625/2
.equ TIMER0_N								= 8
.equ TIMER0_CTC								=(TAKT/(2*TIMER0_N*TIMER0_CTC_FREQUENZ))-1
.equ TIMER0_FREQUENZ_BERECHNET				=TAKT/(2*(TIMER0_N)*(1+TIMER0_CTC))

	; TCCR0A  Timer/Counter Control Register A		
	ldi temp, (0<<COM0A1)| (1<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(0<<WGM00)
	OUT TCCR0A,temp
	; TCCR0B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC0A)| (0<<FOC0B)|(0<<WGM02)|(0<<CS02)|(1<<CS01)|(0<<CS00)
	OUT TCCR0B,temp
	; TIMSK0  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE0B)| (1<<OCIE0A)|(0<<TOIE0)
	STS TIMSK0,temp
	; OCR0A  Output Compare Register A				
	ldi temp,(TIMER0_CTC)
	OUT OCR0A,temp
	; STARTWERT										
	OUT TCNT0,NULL
	; auf AUSGANG (15625/2=7.812,5 Hz)									
;	sbi DDRB,PB3	; PIN OC0A
;	sbi DDRB,PB4	; PIN OC0B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CS22 CS21 CS20																
;*	0 	0 	1 	clkT2S/(No prescaling)											
;																				
; TIMER2 8-BIT-TIMER															
; Fr TAKTKORREKTUR beim INTERRUPTAUFRUF										
TIMER2_INITIALISIERUNG_TAKTKORREKTUR:
	; TCCR2A  Timer/Counter Control Register A		
	ldi temp, (0<<COM2A1)|(0<<COM2A0)|(0<<COM2B1)|(0<<COM2B0)|(0<<WGM21)|(0<<WGM20 )
	STS TCCR2A,temp
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)|(0<<FOC2B)|(0<<WGM22)|(0<<CS22)|(0<<CS21)|(1<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(0<<TOIE2)
	STS TIMSK2,temp
	; Synchronisation mit Timer-0 !!!				
	OUT TCNT0,NULL
	STS TCNT2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



