; ##############################################################################
; ##############################################################################
; ##############################################################################
; USBS Bit Settings							
; USBSn Stop Bit(s)							
; 	0 	1-bit								
; 	1 	2-bit								
; Character Size							
; UCSZn2 	UCSZn1 	UCSZn0 	Character Size	
; 	0 		0 		0 		5-bit			
; 	0 		0 		1 		6-bit			
; 	0 		1 		0 		7-bit			
; 	0 		1 		1 		8-bit			
USART_INITIALISIERUNG:
.equ BAUD=9600
	ldi temp1,TAKT/(BAUD*16)-1  		; Baudrate 	
	ldi temp2,0
	STS UBRR0H, temp2
	STS UBRR0L, temp1
; Enable receiver and transmitter
	ldi temp,(1<<RXCIE0)|(0<<TXCIE0)|(0<<UDRIE0)|(1<<RXEN0)|(1<<TXEN0)|(0<<UCSZ02)|(0<<RXB80)|(0<< TXB80)|(0<<UCSR0B)
	STS UCSR0B,temp
; Set frame format: 8data, 2stop bit		
	ldi temp,(0<<UMSEL01)|(0<<UMSEL00)|(0<<UPM01)|(0<<UPM00)|(1<<USBS0)|(1<<UCSZ01)|(1<<UCSZ00)|(0<<UCPOL0)
	STS UCSR0C,temp


	cbi (USART_RX_DDR) ,(USART_RX_PIN_NR)	; Eingang
	sbi (USART_RX_PORT),(USART_RX_PIN_NR)	; Pull-Up

	sbi (USART_TX_DDR) ,(USART_TX_PIN_NR)	; Eingang
	sbi (USART_TX_PORT),(USART_TX_PIN_NR)	; 		 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_RX_OFF:
	ldi temp,(0<<RXCIE0)|(0<<TXCIE0)|(0<<UDRIE0)|(0<<RXEN0)|(1<<TXEN0)|(0<<UCSZ02)|(0<<RXB80)|(0<< TXB80)|(0<<UCSR0B)
	STS UCSR0B,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_TX_TEMP:
	push temp
USART_TX_TEMP_w:
	; Wait for empty transmit buffer
	WDR
	LDS  temp,UCSR0A
	SBRS temp,UDRE0
	rjmp USART_TX_TEMP_w
	pop temp
; Send DATA					
	STS UDR0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; USART0 RX Complete															
USART0_RXC:
	push ZL
	LDS ZL, UDR0		; RX-DATA						
	sei					; Interrupts wieder freigeben	
	push ZH
	push TEMP		    ; "TEMP" sichern				
	in	 TEMP,SREG		; Einlesen des SREG 			
	push TEMP	    	; SREG sichern					
;-------------------------------------------------------------------------------
	LED_GRUEN_ON
	ldi temp,(USART_TIMER)
	STS(adr_USART_TIMER),temp
;-------------------------------------------------------------------------------
	mov temp,ZL
	cpi temp,13+1		; ignorieren		
	brlo USART0_RXC_EXIT
;-------------------------------------------------------------------------------
	LDS ZL,(adr_USART_ZEIGER_L)
	LDS ZH,(adr_USART_ZEIGER_H)
	cpi ZH,high(adr_GPS_BUFFER + GPS_BUFFER_LEN) ; high	
	brlo USART0_RXC_OK
	breq USART0_RXC_L
	rjmp USART0_RXC_EXIT
USART0_RXC_L:
	cpi ZL,low (adr_GPS_BUFFER + GPS_BUFFER_LEN) ; low	
	brlo USART0_RXC_OK
	rjmp USART0_RXC_EXIT
;-------------------------------------------------------------------------------
USART0_RXC_OK:
	ST Z+,temp
	STS(adr_USART_ZEIGER_L),ZL
	STS(adr_USART_ZEIGER_H),ZH
;-------------------------------------------------------------------------------
USART0_RXC_EXIT:
	pop	TEMP			; LESEN von SREG				
	out	SREG,TEMP		; Wiederherstellen von SREG		
	pop	TEMP			; Wiederherstellen von "TEMP" 	
	pop ZH
	pop ZL
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
